pcl::SampleConsensusModelLine< PointT > Class Template Reference
Module sample_consensus

SampleConsensusModelLine defines a model for 3D line segmentation. More...

`#include <pcl/sample_consensus/sac_model_line.h>`

Inheritance diagram for pcl::SampleConsensusModelLine< PointT >:

## Public Types

using | PointCloud = typename SampleConsensusModel< PointT >::PointCloud
using | PointCloudPtr = typename SampleConsensusModel< PointT >::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModel< PointT >::PointCloudConstPtr
using | Ptr = shared_ptr< SampleConsensusModelLine< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModelLine< PointT > >
Public Types inherited from pcl::SampleConsensusModel< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointCloudPtr = typename PointCloud::Ptr
using | SearchPtr = typename pcl::search::Search< PointT >::Ptr
using | Ptr = shared_ptr< SampleConsensusModel< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModel< PointT > >

## Public Member Functions

| SampleConsensusModelLine (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelLine. More...
| SampleConsensusModelLine (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModelLine. More...
| ~SampleConsensusModelLine ()
| Empty destructor. More...
bool | computeModelCoefficients (const std::vector< int > &samples, Eigen::VectorXf &model_coefficients) const override
| Check whether the given index samples can form a valid line model, compute the model coefficients from these samples and store them internally in model_coefficients_. More...
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances) const override
| Compute all squared distances from the cloud data to a given line model. More...
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, std::vector< int > &inliers) override
| Select all the points which respect the given model coefficients as inliers. More...
std::size_t | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Count all the points which respect the given model coefficients as inliers. More...
void | optimizeModelCoefficients (const std::vector< int > &inliers, const Eigen::VectorXf &model_coefficients, Eigen::VectorXf &optimized_coefficients) const override
| Recompute the line coefficients using the given inlier set and return them to the user. More...
void | projectPoints (const std::vector< int > &inliers, const Eigen::VectorXf &model_coefficients, PointCloud &projected_points, bool copy_data_fields=true) const override
| Create a new point cloud with inliers projected onto the line model. More...
bool | doSamplesVerifyModel (const std::set< int > &indices, const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Verify whether a subset of indices verifies the given line model coefficients. More...
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_LINE). More...
Public Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModel. More...
| SampleConsensusModel (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModel. More...
virtual | ~SampleConsensusModel ()
| Destructor for base SampleConsensusModel. More...
virtual void | getSamples (int &iterations, std::vector< int > &samples)
| Get a set of random data samples and return them as point indices. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const std::vector< int > &indices)
| Provide the vector of indices that represents the input data. More...
IndicesPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
unsigned int | getSampleSize () const
| Return the size of a sample from which the model is computed. More...
unsigned int | getModelSize () const
| Return the number of coefficients in the model. More...
void | setRadiusLimits (const double &min_radius, const double &max_radius)
| Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius) More...
void | getRadiusLimits (double &min_radius, double &max_radius) const
| Get the minimum and maximum allowable radius limits for the model as set by the user. More...
void | setSamplesMaxDist (const double &radius, SearchPtr search)
| Set the maximum distance allowed when drawing random samples. More...
void | getSamplesMaxDist (double &radius) const
| Get maximum distance allowed when drawing random samples. More...
double | computeVariance (const std::vector< double > &error_sqr_dists) const
| Compute the variance of the errors to the model. More...
double | computeVariance () const
| Compute the variance of the errors to the model from the internally estimated vector of distances. More...

## Protected Member Functions

bool | isSampleGood (const std::vector< int > &samples) const override
| Check if a sample of indices results in a good sample of points indices. More...
Protected Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (bool random=false)
| Empty constructor for base SampleConsensusModel. More...
void | drawIndexSample (std::vector< int > &sample)
| Fills a sample array with random samples from the indices_ vector. More...
void | drawIndexSampleRadius (std::vector< int > &sample)
| Fills a sample array with one random sample from the indices_ vector and other random samples that are closer than samples_radius_. More...
virtual bool | isModelValid (const Eigen::VectorXf &model_coefficients) const
| Check whether a model is valid given the user constraints. More...
int | rnd ()
| Boost-based random number generator. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
std::string | model_name_
| The model name. More...
PointCloudConstPtr | input_
| A boost shared pointer to the point cloud data array. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
double | radius_min_
| The minimum and maximum radius limits for the model. More...
double | radius_max_
double | samples_radius_
| The maximum distance of subsequent samples from the first (radius search) More...
SearchPtr | samples_radius_search_
| The search object for picking subsequent samples using radius search. More...
std::vector< int > | shuffled_indices_
| Data containing a shuffled version of the indices. More...
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm. More...
std::shared_ptr< boost::uniform_int<> > | rng_dist_
| Boost-based random number generator distribution. More...
std::shared_ptr< boost::variate_generator< boost::mt19937 &, boost::uniform_int<> > > | rng_gen_
| Boost-based random number generator. More...
std::vector< double > | error_sqr_dists_
| A vector holding the distances to the computed model. More...
unsigned int | sample_size_
| The size of a sample from which the model is computed. More...
unsigned int | model_size_
| The number of coefficients in the model. More...
Static Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
static const unsigned int | max_sample_checks_ = 1000
| The maximum number of samples to try until we get a good one. More...

## Detailed Description

### template<typename PointT>
class pcl::SampleConsensusModelLine< PointT >

SampleConsensusModelLine defines a model for 3D line segmentation.

The model coefficients are defined as:

- point_on_line.x : the X coordinate of a point on the line
- point_on_line.y : the Y coordinate of a point on the line
- point_on_line.z : the Z coordinate of a point on the line
- line_direction.x : the X coordinate of a line's direction
- line_direction.y : the Y coordinate of a line's direction
- line_direction.z : the Z coordinate of a line's direction

Author
  Radu B. Rusu

Definition at line 62 of file sac_model_line.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

using pcl::SampleConsensusModelLine< PointT >::ConstPtr = shared_ptr<const SampleConsensusModelLine<PointT> >

Definition at line 76 of file sac_model_line.h.

## PointCloud

template<typename PointT>

using pcl::SampleConsensusModelLine< PointT >::PointCloud = typename SampleConsensusModel<PointT>::PointCloud

Definition at line 71 of file sac_model_line.h.

## PointCloudConstPtr

template<typename PointT>

using pcl::SampleConsensusModelLine< PointT >::PointCloudConstPtr = typename SampleConsensusModel<PointT>::PointCloudConstPtr

Definition at line 73 of file sac_model_line.h.

## PointCloudPtr

template<typename PointT>

using pcl::SampleConsensusModelLine< PointT >::PointCloudPtr = typename SampleConsensusModel<PointT>::PointCloudPtr

Definition at line 72 of file sac_model_line.h.

## Ptr

template<typename PointT>

using pcl::SampleConsensusModelLine< PointT >::Ptr = shared_ptr<SampleConsensusModelLine<PointT> >

Definition at line 75 of file sac_model_line.h.

## Constructor & Destructor Documentation

## SampleConsensusModelLine() [1/2]

template<typename PointT>

pcl::SampleConsensusModelLine< PointT >::SampleConsensusModelLine | ( | const PointCloudConstPtr & | cloud,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelLine.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 82 of file sac_model_line.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## SampleConsensusModelLine() [2/2]

template<typename PointT>

pcl::SampleConsensusModelLine< PointT >::SampleConsensusModelLine | ( | const PointCloudConstPtr & | cloud,
|  | const std::vector< int > & | indices,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelLine.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | indices | a vector of point indices to be used from cloud
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 95 of file sac_model_line.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## ~SampleConsensusModelLine()

template<typename PointT>

pcl::SampleConsensusModelLine< PointT >::~SampleConsensusModelLine | ( |  | ) |

inline

Empty destructor.

Definition at line 106 of file sac_model_line.h.

## Member Function Documentation

## computeModelCoefficients()

template<typename PointT >

bool pcl::SampleConsensusModelLine< PointT >::computeModelCoefficients | ( | const std::vector< int > & | samples,
|  | Eigen::VectorXf & | model_coefficients
| ) |  | const

override virtual

Check whether the given index samples can form a valid line model, compute the model coefficients from these samples and store them internally in model_coefficients_.

The line coefficients are represented by a point and a line direction

Parameters

  [in] | samples | the point indices found as possible good candidates for creating a valid model
  [out] | model_coefficients | the resultant model coefficients

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 68 of file sac_model_line.hpp.

## countWithinDistance()

template<typename PointT >

std::size_t pcl::SampleConsensusModelLine< PointT >::countWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold
| ) |  | const

override virtual

Count all the points which respect the given model coefficients as inliers.

Parameters

  [in] | model_coefficients | the coefficients of a model that we need to compute distances to
  [in] | threshold | maximum admissible distance threshold for determining the inliers from the outliers

Returns
  the resultant number of inliers

Implements pcl::SampleConsensusModel< PointT >.

Reimplemented in pcl::SampleConsensusModelParallelLine< PointT >.

Definition at line 165 of file sac_model_line.hpp.

## doSamplesVerifyModel()

template<typename PointT >

bool pcl::SampleConsensusModelLine< PointT >::doSamplesVerifyModel | ( | const std::set< int > & | indices,
|  | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold
| ) |  | const

override virtual

Verify whether a subset of indices verifies the given line model coefficients.

Parameters

  [in] | indices | the data indices that need to be tested against the line model
  [in] | model_coefficients | the line model coefficients
  [in] | threshold | a maximum admissible distance threshold for determining the inliers from the outliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 310 of file sac_model_line.hpp.

## getDistancesToModel()

template<typename PointT >

void pcl::SampleConsensusModelLine< PointT >::getDistancesToModel | ( | const Eigen::VectorXf & | model_coefficients,
|  | std::vector< double > & | distances
| ) |  | const

override virtual

Compute all squared distances from the cloud data to a given line model.

Parameters

  [in] | model_coefficients | the coefficients of a line model that we need to compute distances to
  [out] | distances | the resultant estimated squared distances

Implements pcl::SampleConsensusModel< PointT >.

Reimplemented in pcl::SampleConsensusModelParallelLine< PointT >.

Definition at line 100 of file sac_model_line.hpp.

## getModelType()

template<typename PointT>

pcl::SacModel pcl::SampleConsensusModelLine< PointT >::getModelType | ( |  | ) | const

inline override virtual

Return a unique id for this model (SACMODEL_LINE).

Implements pcl::SampleConsensusModel< PointT >.

Reimplemented in pcl::SampleConsensusModelParallelLine< PointT >.

Definition at line 181 of file sac_model_line.h.

References pcl::SACMODEL_LINE.

## isSampleGood()

template<typename PointT >

bool pcl::SampleConsensusModelLine< PointT >::isSampleGood | ( | const std::vector< int > & | samples | ) | const

override protected virtual

Check if a sample of indices results in a good sample of points indices.

Parameters

  [in] | samples | the resultant index samples

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 50 of file sac_model_line.hpp.

## optimizeModelCoefficients()

template<typename PointT >

void pcl::SampleConsensusModelLine< PointT >::optimizeModelCoefficients | ( | const std::vector< int > & | inliers,
|  | const Eigen::VectorXf & | model_coefficients,
|  | Eigen::VectorXf & | optimized_coefficients
| ) |  | const

override virtual

Recompute the line coefficients using the given inlier set and return them to the user.

Note
  : these are the coefficients of the line model after refinement (e.g. after SVD)

Parameters

  [in] | inliers | the data inliers found as supporting the model
  [in] | model_coefficients | the initial guess for the model coefficients
  [out] | optimized_coefficients | the resultant recomputed coefficients after optimization

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 196 of file sac_model_line.hpp.

References pcl::compute3DCentroid(), pcl::computeCorrespondingEigenVector(), pcl::computeCovarianceMatrix(), and pcl::eigen33().

## projectPoints()

template<typename PointT >

void pcl::SampleConsensusModelLine< PointT >::projectPoints | ( | const std::vector< int > & | inliers,
|  | const Eigen::VectorXf & | model_coefficients,
|  | PointCloud & | projected_points,
|  | bool | copy_data_fields = `true`
| ) |  | const

override virtual

Create a new point cloud with inliers projected onto the line model.

Parameters

  [in] | inliers | the data inliers that we want to project on the line model
  [in] | model_coefficients | the normalized coefficients of a line model
  [out] | projected_points | the resultant projected points
  [in] | copy_data_fields | set to true if we need to copy the other data fields

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 237 of file sac_model_line.hpp.

References pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

## selectWithinDistance()

template<typename PointT >

void pcl::SampleConsensusModelLine< PointT >::selectWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold,
|  | std::vector< int > & | inliers
| ) |  |

override virtual

Select all the points which respect the given model coefficients as inliers.

Parameters

  [in] | model_coefficients | the coefficients of a line model that we need to compute distances to
  [in] | threshold | a maximum admissible distance threshold for determining the inliers from the outliers
  [out] | inliers | the resultant model inliers

Implements pcl::SampleConsensusModel< PointT >.

Reimplemented in pcl::SampleConsensusModelParallelLine< PointT >.

Definition at line 126 of file sac_model_line.hpp.

The documentation for this class was generated from the following files:

- pcl/sample_consensus/sac_model_line.h
- pcl/sample_consensus/impl/sac_model_line.hpp